<!--
 * @Descripttion: (商品/tb_goods)
 * @version: (1.0)
 * @Author: (lwh)
 * @Date: (2023-06-19)
 * @LastEditors: (lwh)
 * @LastEditTime: (2023-06-19)
-->
<template>
  <div class="app-container">
    <el-row :gutter="24">
      <!-- 搜索框 queryParams.需要搜索的字段 -->
      <el-form :model="queryParams" label-position="left" style="margin:15px;" inline ref="queryForm" v-show="showSearch"
        @submit.prevent>
        <el-form-item label="店铺名称">
          <el-input v-model.number="queryParams.shopName" placeholder="请输入店铺名称" clearable @keyup.enter="handleQuery" />
        </el-form-item>
        <el-form-item label="经营类目" prop="goodsCategoryGuid" v-if="userid == 1">
          <el-cascader class="w100" :options="goodsCategoryTreeListData"
            :props="{ checkStrictly: true, value: 'goodsCategoryGuid', label: 'goodsCategoryName', emitPath: false }"
            placeholder="请选择经营类目" clearable v-model="queryParams.goodsCategoryGuid" @change="handleQuery">
            <template #default="{ node, data }">
              <span>{{ data.goodsCategoryName }}</span>
              <span v-if="!node.isLeaf"> ({{ data.children.length }}) </span>
            </template>
          </el-cascader>
        </el-form-item>
        <el-form-item label="商品类目" prop="goodsCategoryGuid" v-else>
          <el-cascader class="w100" :options="shopGoodsCategoryTreeListData"
            :props="{ checkStrictly: true, value: 'shopGoodsCategoryGuid', label: 'shopGoodsCategoryName', emitPath: false }"
            placeholder="请选择商品类目" clearable v-model="queryParams.shopGoodsCategoryGuid" @change="handleQuery">
            <template #default="{ node, data }">
              <span>{{ data.shopGoodsCategoryName }}</span>
              <span v-if="!node.isLeaf"> ({{ data.children.length }}) </span>
            </template>
          </el-cascader>
        </el-form-item>
        <el-form-item label="商品名称" prop="goodsName">
          <el-input v-model="queryParams.goodsName" placeholder="请输入商品名称" clearable @keyup.enter="handleQuery" />
        </el-form-item>
        <el-form-item label="商品编码" prop="goodsCoding">
          <el-input v-model="queryParams.goodsCoding" placeholder="请输入商品编码" clearable @keyup.enter="handleQuery" />
        </el-form-item>
        <el-form-item>
          <el-button icon="search" type="primary" @click="handleQuery">{{ $t('btn.search') }}</el-button>
          <el-button icon="refresh" @click="resetQuery">{{ $t('btn.reset') }}</el-button>
        </el-form-item>
      </el-form>
    </el-row>

    <!-- 工具按钮 -->
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" v-hasPermi="['business:goods:addOrUpdate']" plain icon="plus"
          @click="AddDialogVisible = true">
          {{ $t('btn.add') }}
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="danger" :disabled="multiple" v-hasPermi="['business:goods:delete']" plain icon="delete"
          @click="handleDelete">
          {{ $t('btn.delete') }}
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="primary" plain icon="Upload" @click="UploadDialogVisible = true"
          v-hasPermi="['business:goods:import']">导入</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="download" @click="handleExport" v-hasPermi="['business:goods:export']">
          {{ $t('btn.export') }}
        </el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <!-- 表格渲染  prop="对应的字段"-->
    <el-table v-loading="loading" :data="dataList" ref="tableRef" highlight-current-row
      @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="50" align="center" />

      <el-table-column prop="goodsId" width="100" label="商品ID" align="center" :show-overflow-tooltip="true" />
      <el-table-column prop="shopName" width="150" label="店铺名称" align="center" :show-overflow-tooltip="true"
        v-if="userid == 1" />
      <el-table-column prop="goodsPicture" label="图片" align="center">
        <template #default="scope">
          <el-image preview-teleported :hide-on-click-modal="true" lazy class="table-td-thumb" fit="contain"
            :src="scope.row.goodsPicture?.split(',')[0]" :preview-src-list="scope.row.goodsPicture?.split(',')">
            <div><el-icon :size="15">
                <document />
              </el-icon></div>
          </el-image>
        </template>
      </el-table-column>
      <el-table-column prop="goodsName" label="商品名称" width="450" align="center" :show-overflow-tooltip="true" />
      <el-table-column prop="goodsPriceLowest" label="价格" align="center" />
      <el-table-column prop="goodsSalesActual" label="实际销量" align="center" />
      <el-table-column prop="goodsTotalInventory" label="库存总量" align="center" />
      <el-table-column prop="goodsShelfStatus" label="状态" align="center">
        <template #default="scope">
          <dict-tag :options="shelf_status" :value="scope.row.goodsShelfStatus" />
        </template>
      </el-table-column>
      <el-table-column prop="goodsSort" label="排序" align="center" />
      <el-table-column prop="createTime" label="添加时间" width="150" align="center" />

      <el-table-column label="操作" width="250" fixed="right" align="center">
        <template #default="scope">
          <el-button type="primary" size="small" icon="edit" @click="handleUpdate(scope.row)"
            v-hasPermi="['business:goods:addOrUpdate']">编辑</el-button>
          <el-button type="danger" size="small" icon="delete" @click="handleDelete(scope.row)"
            v-hasPermi="['business:goods:delete']">删除</el-button>
          <!-- <el-button size="small" icon="view" @click="handleDetail(scope.row)">查看</el-button> -->
        </template>
      </el-table-column>

    </el-table>
    <pagination :total="total" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize"
      @pagination="getList" />
  </div>

  <!-- 添加 -->
  <AddDialog v-model="AddDialogVisible" :done="() => resetQuery()"></AddDialog>
  <!-- 编辑 -->
  <EditDialog v-model="EditDialogVisible" :data="EditDialogRow" :done="() => resetQuery()"></EditDialog>
  <!-- 详情 -->
  <DetailDialog v-model="DetailDialogVisible" :data="DetailDialogRow" :done="() => resetQuery()"></DetailDialog>
  <!-- 导入 -->
  <UploadDialog v-model="UploadDialogVisible" :done="() => resetQuery()"></UploadDialog>
</template>
<script setup name="goods">
import { ElMessageBox } from 'element-plus'
import modal from '@/plugins/modal.js'
import { exportGoods, goodsList, delGoods } from '@/api/business/GoodsManager/Goodss/goods.js'
import { goodsCategoryTreeList } from '@/api/business/GoodsManager/GoodsCategorys/goodsCategory.js'
import { shopGoodsCategoryTreeList } from '@/api/business/GoodsManager/ShopGoodsCategorys/shopGoodsCategory.js'
import AddDialog from "./components/AddDialog.vue";
import EditDialog from "./components/EditDialog.vue";
import DetailDialog from "./components/DetailDialog.vue";
import UploadDialog from "./components/UploadDialog.vue";
import useUserStore from '@/store/modules/user'

const AddDialogVisible = ref(false);
const EditDialogVisible = ref(false);
const EditDialogRow = ref({});
const DetailDialogVisible = ref(false);
const DetailDialogRow = ref({});
const UploadDialogVisible = ref(false);

const { proxy } = getCurrentInstance()

// 选中categoryId数组数组
const ids = ref([])
// 非单选禁用
const single = ref(true)
// 非多个禁用
const multiple = ref(true)
// 显示搜索条件
const showSearch = ref(true)
// 数据列表
const dataList = ref([])
// 总记录数
const total = ref(0)
// 是否加载
const loading = ref(true)


const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10
  },
})
const { queryParams } = toRefs(data)

// 业务参数
const userid = useUserStore().userId


// 业务方法

// 字典获取
const deduct_stock_type = ref([]);
async function getdeduct_stock_type() {
  await proxy.getDicts('deduct_stock_type').then((res) => {
    deduct_stock_type.value = res.data
  })
}
getdeduct_stock_type()
// 字典获取
const is_points_gift = ref([]);
async function getis_points_gift() {
  await proxy.getDicts('is_points_gift').then((res) => {
    is_points_gift.value = res.data
  })
}
getis_points_gift()
// 字典获取
const is_points_discount = ref([]);
async function getis_points_discount() {
  await proxy.getDicts('is_points_discount').then((res) => {
    is_points_discount.value = res.data
  })
}
getis_points_discount()
// 字典获取
const is_alone_points_discount = ref([]);
async function getis_alone_points_discount() {
  await proxy.getDicts('is_alone_points_discount').then((res) => {
    is_alone_points_discount.value = res.data
  })
}
getis_alone_points_discount()
// 字典获取
const is_enable_grade = ref([]);
async function getis_enable_grade() {
  await proxy.getDicts('is_enable_grade').then((res) => {
    is_enable_grade.value = res.data
  })
}
getis_enable_grade()
// 字典获取
const is_alone_grade = ref([]);
async function getis_alone_grade() {
  await proxy.getDicts('is_alone_grade').then((res) => {
    is_alone_grade.value = res.data
  })
}
getis_alone_grade()
// 字典获取
const shelf_status = ref([]);
async function getshelf_status() {
  await proxy.getDicts('shelf_status').then((res) => {
    shelf_status.value = res.data
  })
}
getshelf_status()


// 获取商品类目树形列表
const shopGoodsCategoryTreeListData = ref([])
async function getShopGoodsCategoryTreeList() {
  shopGoodsCategoryTreeList().then((res) => {
    if (res.code == 200) {
      shopGoodsCategoryTreeListData.value = res.data
    }
  })
}
getShopGoodsCategoryTreeList()

// 获取经营类目树形列表
const goodsCategoryTreeListData = ref([])
async function getGoodsCategoryTreeList() {
  goodsCategoryTreeList().then((res) => {
    if (res.code == 200) {
      goodsCategoryTreeListData.value = res.data
    }
  })
}
getGoodsCategoryTreeList()

//基础方法

// 查询数据
function getList() {
  loading.value = true


  goodsList(queryParams.value).then((res) => {
    if (res.code == 200) {
      loading.value = false;
      dataList.value = res.data.result;
      total.value = res.data.totalNum;
    }
  });
}


// 多选框选中数据
function handleSelectionChange(selection) {
  console.log(selection,'检查 selection 中的内容'); // 检查 selection 中的内容
  ids.value = selection.map((item) => item.goodsId)
  single.value = selection.length != 1
  multiple.value = !selection.length
}

/** 重置查询操作 */
function resetQuery() {
  proxy.resetForm('queryForm')
  handleQuery()
}
/** 搜索按钮操作 */
function handleQuery() {
  getList()
}
/** 删除按钮操作 */
function handleDelete(row) {
  const Ids = row.goodsId || ids.value

  ElMessageBox.confirm("是否确认删除？", "系统提示", {
    confirmButtonText: '确定',
    cancelButtonText: '取消',
    type: "warning",
  })
    .then(function () {
      return delGoods(Ids)
    })
    .then(() => {
      handleQuery()
      modal.msgSuccess("删除成功")
    })
    .catch(() => { })
}

/** 导出按钮操作 */
function handleExport(row) {
  const Ids = row.goodsId || ids.value
  const name = ref("所有")
  if (Ids.length != 0) {
    const ids = Object.values(Ids).map(value => String(value));
    const str = ids.join(',');
    queryParams.value.ids = str
    name.value = "选中"
  }

  ElMessageBox.confirm('是否确认导出' + name.value + '数据?', '警告', {
    confirmButtonText: '确定',
    cancelButtonText: '取消',
    type: 'warning',
  })
    .then(function () {
      return exportGoods(queryParams.value)
    })
    .then((response) => {
      proxy.download(response.data.path)
    })
}


// 修改
function handleUpdate(row) {
  EditDialogVisible.value = true
  EditDialogRow.value = row
}

// 详情
function handleDetail(row) {
  DetailDialogVisible.value = true
  DetailDialogRow.value = row
}

handleQuery()
</script>
